/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2003 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.0 of the PHP license,       |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_0.txt.                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author: Evan Nemerson                                                |
  +----------------------------------------------------------------------+
*/

/* $Id$ */

#ifndef PHP_PANDA_H
#define PHP_PANDA_H

#include <panda/functions.h>
#include <panda/constants.h>

extern zend_module_entry panda_module_entry;
#define phpext_panda_ptr &panda_module_entry

#if PHP_MAJOR_VERSION >= 5
#define PHP_PANDA_OO 1
#endif

#ifdef PHP_WIN32
#define PHP_PANDA_API __declspec(dllexport)
#else
#define PHP_PANDA_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

typedef struct php_panda_page_node {
	struct php_panda_page_node *prevPage;
	panda_page *page;
	struct php_panda_page_node *nextPage;
} php_panda_page;

typedef struct {
	int pages;
	panda_pdf *PDF;
	php_panda_page *currPage;
} php_panda_pdf;

PHP_MINIT_FUNCTION(panda);
PHP_MSHUTDOWN_FUNCTION(panda);
PHP_RINIT_FUNCTION(panda);
PHP_RSHUTDOWN_FUNCTION(panda);
PHP_MINFO_FUNCTION(panda);

PHP_FUNCTION(panda_add_cubic_curve_segment);
PHP_FUNCTION(panda_add_line_segment);
PHP_FUNCTION(panda_add_quadratic_curve_segment);
PHP_FUNCTION(panda_center_window);
PHP_FUNCTION(panda_close);
PHP_FUNCTION(panda_close_line);
PHP_FUNCTION(panda_end_line);
PHP_FUNCTION(panda_fast_forward);
PHP_FUNCTION(panda_fill_line);
PHP_FUNCTION(panda_fit_window);
PHP_FUNCTION(panda_full_screen);
PHP_FUNCTION(panda_open);
PHP_FUNCTION(panda_get_num_pages);
PHP_FUNCTION(panda_get_page_height);
PHP_FUNCTION(panda_get_page_width);
PHP_FUNCTION(panda_get_string_width);
PHP_FUNCTION(panda_hide_menu_bar);
PHP_FUNCTION(panda_hide_tool_bar);
PHP_FUNCTION(panda_hide_window_ui);
PHP_FUNCTION(panda_image_box);
PHP_FUNCTION(panda_make_line);
PHP_FUNCTION(panda_make_page_size);
PHP_FUNCTION(panda_new_page);
PHP_FUNCTION(panda_next_page);
PHP_FUNCTION(panda_nfs_page_mode);
PHP_FUNCTION(panda_open);
PHP_FUNCTION(panda_page_duration);
PHP_FUNCTION(panda_prev_page);
PHP_FUNCTION(panda_rectangle);
PHP_FUNCTION(panda_rewind);
PHP_FUNCTION(panda_set_author);
PHP_FUNCTION(panda_set_compression);
PHP_FUNCTION(panda_set_fill_color);
PHP_FUNCTION(panda_set_font);
PHP_FUNCTION(panda_set_font_size);
PHP_FUNCTION(panda_set_horizontal_scaling);
PHP_FUNCTION(panda_set_keywords);
PHP_FUNCTION(panda_set_leading);
PHP_FUNCTION(panda_set_line_cap);
PHP_FUNCTION(panda_set_line_color);
PHP_FUNCTION(panda_set_line_dash);
PHP_FUNCTION(panda_set_line_join);
PHP_FUNCTION(panda_set_line_start);
PHP_FUNCTION(panda_set_line_width);
PHP_FUNCTION(panda_set_subject);
PHP_FUNCTION(panda_set_text_mode);
PHP_FUNCTION(panda_set_title);
PHP_FUNCTION(panda_set_word_spacing);
PHP_FUNCTION(panda_stroke_line);
PHP_FUNCTION(panda_text_annotation);
PHP_FUNCTION(panda_text_box);
PHP_FUNCTION(panda_text_direction);
PHP_FUNCTION(panda_trans_duration);
PHP_FUNCTION(panda_trans_style);
PHP_FUNCTION(panda_uri_link);
PHP_FUNCTION(panda_link);

#ifdef PHP_PANDA_OO
PHP_METHOD(panda, __set);
#endif

#ifdef ZTS
#define PANDA_G(v) TSRMG(panda_globals_id, zend_panda_globals *, v)
#else
#define PANDA_G(v) (panda_globals.v)
#endif

#endif	/* PHP_PANDA_H */

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
